﻿using Infragistics.Controls.Grids;
using Infragistics.Documents.Excel;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XSLoadPreviousActiveSheet
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        SpreadsheetCell lastActiveCell;
        SpreadsheetCellRange lastSpreadsheetCellRange;
        Worksheet lastActiveWorksheet;

        public MainWindow()
        {
            InitializeComponent();
            LoadWorkBook();
        }

        private void ResetToSheet1_Click(object sender, RoutedEventArgs e)
        {
            SaveLastActiveWorksheetItems();
            this.spreadSheet.ActiveWorksheet = this.spreadSheet.Workbook.Worksheets["Sheet1"];
        }

        private void ResetToSheet1Scroll_Click(object sender, RoutedEventArgs e)
        {
            SaveLastActiveWorksheetItems();
            this.spreadSheet.ActiveWorksheet = this.spreadSheet.Workbook.Worksheets["Sheet1"];
            ScrollLastReionIntoView();
        }

        private void SaveLastActiveWorksheetItems()
        {
            this.lastActiveWorksheet = spreadSheet.ActiveWorksheet;
            this.lastActiveCell = spreadSheet.ActiveCell;
            this.lastSpreadsheetCellRange = spreadSheet.ActivePane.VisibleRange;
        }

        private void ScrollLastReionIntoView()
        {
            this.spreadSheet.ActivePane.ScrollRangeIntoView(this.lastSpreadsheetCellRange);
            //this.spreadSheet.ActivePane.ScrollCellIntoView(this.lastActiveCell);
        }

        private void SaveWorkbook_Click(object sender, RoutedEventArgs e)
        {
            spreadSheet.Workbook.Save("../../../Test.xlsx");
        }

        private void ReloadWorkbook_Click(object sender, RoutedEventArgs e)
        {
            LoadWorkBook();
        }

        private void LoadWorkBook()
        {
            using (var fs = File.OpenRead("../../../Test.xlsx"))
            {
                // Load Worksheet
                var workbook = Workbook.Load(fs);

                spreadSheet.Workbook = workbook;
            }
        }

    }
}
